/**************************************
   Generic HID Class implementation
 -------------------------------------
 Created by David Guillen (davidgf.net)
    Nice and incomplete macros for
       creating HID descriptors
 -------------------------------------
 The code is under the public domain
***************************************/

#ifndef HID_MACROS__H__
#define HID_MACROS__H__

#define HID_USAGE_GENERIC_DESKTOP 0x01
#define HID_USAGE_BUTTON          0x09
#define HID_USAGE_MOUSE           0x02
#define HID_USAGE_POINTER         0x01
#define HID_COLLECTION_APP        0x01
#define HID_COLLECTION_PHY        0x00
#define HID_COLLECTION_END        0xC0

#define HID_X_AXIS        0x30
#define HID_Y_AXIS        0x31

#define HID_USAGE_PAGE(v) 0x05,v
#define HID_USAGE(v) 0x09,v
#define HID_COLLECTION(v) 0xA1,v

#define HID_LOG_MIN(v) 0x15,v
#define HID_LOG_MAX(v) 0x25,v
#define HID_USAGE_MIN(v) 0x19,v
#define HID_USAGE_MAX(v) 0x29,v

#define HID_REPORT_SZ(v)    0x75,v
#define HID_REPORT_COUNT(v) 0x95,v

#define HID_INPUT(a) 0x81,a

#endif
