/**************************************
        Generic macros for PIC
 -------------------------------------
 Created by David Guillen (davidgf.net)
 -------------------------------------
 The code is under the public domain
***************************************/

#ifndef _MACROS_H_
#define _MACROS_H_

// GENERAL DEFINITIONS
#define TRISTATE_PIN_OUT 0
#define TRISTATE_PIN_IN  1

// Interrupt handling

#define EI() INTCONbits.GIE = 1;
#define DI() INTCONbits.GIE = 0;

#define TMR0_CLR_FLAG() INTCONbits.TMR0IF = 0;
#define TMR0_FLAG() INTCONbits.TMR0IF

#define SET_TMR0(enabled,bit8,presc) T0CON = ((enabled&1) << 7) | ((bit8&1) << 6) | (presc&07);
#define EI_TMR0() INTCONbits.TMR0IE = 1;

#define USBEI() PIE2bits.USBIE = 1; INTCONbits.PEIE = 1;
#define USB_CLR_FLAG() PIR2bits.USBIF = 0;
#define USB_FLAG() PIR2bits.USBIF


#endif

